unit exp_sub;

interface

uses Velthuis.Bigdecimals, System.SysUtils, Vcl.Forms, Velthuis.BigIntegers, main;

function exp_big(x: bigdecimal): bigdecimal;
function sinh_big(x: bigdecimal): bigdecimal;
function cosh_big(x: bigdecimal): bigdecimal;
function tanh_big(x: bigdecimal): bigdecimal;
function coth_big(x: bigdecimal): bigdecimal;
function sech_big(x: bigdecimal): bigdecimal;
function csch_big(x: bigdecimal): bigdecimal;
function exp_test(x: bigdecimal): bigdecimal;
function hyperbolic(x: bigdecimal; k: integer): bigdecimal;

implementation

// llogvZ
// x 
// dpcs L
// ans logl
// 1e-4`1e4 vZox
function Log_s_big(x: bigdecimal; dpcs: integer): bigdecimal;
var
  one, two, x1, x2, i, s, last: bigdecimal;
begin
  one := '1';
  two := '2';
  x1 := (x - one) / (x + one);                      // x1 = (x-1)/(x+1)
  x2 := x1 * x1;                                    // x1^2
  x2 := x2.RoundToPrecision(dpcs);
  i := one;                                         // i=1
  s := x1;                                          // sl
  repeat
    x1 := x1 * x2;                                  // x1^2n+1
    x1 := x1.RoundToPrecision(dpcs);
    i := i + two;                                   // 2n+1
    last := s;                                      // ps̒lۑ
    s := s + x1 / i;                                // s = s + x1^2n+1 / (2n+1)
    s := s.RoundToPrecision(dpcs);                  // ̈׎wLȉۂ
  until last = s;                                   // 
  result := two * s;
//  Form1.Memo1.Lines.Append(intTostr(k));
end;

// exp(x) e^x p   eC[
// exp(x) = 1 + x + x^2/2! + x^3/3! + x^4/4! ....
function exp_test(x: bigdecimal): bigdecimal;
var
  dpcs : integer;
  a, e, prev, zero, one, two, d : bigdecimal;
  i, ione: bigInteger;
begin
  dpcs := BigDecimal.DefaultPrecision;
  zero := '0';
  one := '1';
  two := '2';
  e := x;                             // exp(t)vZJn e=x
  if x < zero then e := -x;           // x e 
  d := e;                             // d l e = /x/
  a := d;                             // a l d = e = /x/
  i := '2';
  ione := '1';
  repeat
    prev := e;                        // lۑ
    a := a * (d / i);                 // a = (d^i)/(i!)
    a := a.RoundToPrecision(dpcs);
    e := e + a;                       // e = e + (d^i)/(i!)
    e := e.RoundToPrecision(dpcs);
    i := i + ione;                    // inc(i)
  until e = prev;                     // ɂlςȂȂI
  e := e + one;                       // e = 1 + d + d^2/2! + d^3/3! `
  e := e.RoundToPrecision(dpcs);
  one := one.RoundToPrecision(dpcs);
  if x < 0 then e := one / e;         // x瓚͋t
  result := e;
end;

// sub  exp(x)  e^x
// exp(x)=exp(s+t)=exp(s)exp(t)
// k     2̎w@   exp(s)=2^k
// x     exp(t)̒l
// exp(x)=exp(t) * 2^k
// dpcs  L
function expb(x: Bigdecimal; k: bigInteger; dpcs: integer): Bigdecimal;
var
  w : bigdecimal;
  izero, ione, ks : bigInteger;
begin
  izero := '0';
  ione := '1';
  if k >= izero then w := '2'         // k 2  ׂ揉l
           else begin                 // k
             w := '0.5';              // 1/2      ׂ揉l
             k := -k;                 // k->
           end;
  while k <> izero do begin           // k[ɂȂ܂Ŏs exp(t)exp(s)
    if k and ione = ione then begin   // k̍ŉʃrbg1
      x := x * w;                     // exp(t) * 2^k'
      x := x.RoundToPrecision(dpcs);
    end;
    w := w * w;                       // ׂ w=2,4,16,256  2^1.2^2,2^4,2^8
                         // or w = 1/2,1/4,1/16,1/256   0.5^1,0.5^2,0.5^4,0.5^8
    w := w.RoundToPrecision(dpcs);
    bigInteger.ShiftRight(k, 1, ks);  // k̒lEVtg1rbg
    k := ks;
  end;
  result := x;                        // exp(t) * 2^k
end;

// exp(x) e^x
// exp(x)=exp(s+t)=exp(s)exp(t)
// x   e̎w
function expa(x: bigdecimal): bigdecimal;
var
  neg : boolean;
  dpcs : integer;
  t, km, a, e, prev, LOG2, zero, one, two, d : bigdecimal;
  k, i, ione: bigInteger;
begin
  d := '100000000';
  if x > d then begin
    result := '0';
    application.MessageBox('l傫܂B','',0);
    exit;
  end;
  dpcs := BigDecimal.DefaultPrecision;
  zero := '0';
  one := '1';
  two := '2';
  LOG2 := log_s_big(two, dpcs);           // log(2)
  km := x / LOG2;                         //
  km := km.Floor;                         // _ȉ؂̂ 2^km = exp(s)
  t := x - km * LOG2;                     // t  "exp(t)"
//  form1.Memo1.Lines.Append(t.ToPlainString);
  neg := false;
  if t < zero then begin                  // t Ȃ
    neg := true;                          // tOZbg
    t := -t;                              // ] ->
  end;
  e := one + t;                           // exp(t)vZJn eC[ el
  a := t;                                 // al
  i := '2';
  ione := '1';
  repeat
    prev := e;
    a := a * (t / i);                     // a = (t^i)/(i!)
    a := a.RoundToPrecision(dpcs);
    e := e + a;                           // 
    e := e.RoundToPrecision(dpcs);
    i := i + ione;                        // inc(i)
  until e = prev;                         // 
  if neg then e := one / e;               // Ȃt
  k := km.AsBigInteger;                   // float -> int
                                          // e = exp(t)
  result := expb(e, k, dpcs);             // exp(x) = exp(t) * 2^k = exp(t) * exp(s)
end;

// e^x  exp(x)
function exp_big(x: bigDecimal): bigdecimal;
var
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // LobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // ۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // wL + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  x := x.RoundToPrecision(dpcs);
  result := expa(x);

  result := result.RoundToPrecision(pcsBack);         // wLɊۂ
  BigDecimal.DefaultPrecision := pcsBack;             // LA
  BigDecimal.DefaultRoundingMode := rmBack;           // ۂ߃[hA
end;

// sinh(x) = (e^x - e^-x) / 2
function sinh_big(x : bigdecimal): bigdecimal;
var
  dpcs : integer;
  two, a, b, c : bigdecimal;
begin
  dpcs := BigDecimal.DefaultPrecision;              // L
  two := '2';
  x := x.RoundToPrecision(dpcs);
  a := expa(x);
  b := expa(-x);
  c := a - b;
  c := c.RoundToPrecision(dpcs);
  result := c / two;
end;

// cosh(x) = (e^x + e^-x) / 2
function cosh_big(x : bigdecimal): bigdecimal;
var
  dpcs : integer;
  two, a, b, c : bigdecimal;
begin
  dpcs := BigDecimal.DefaultPrecision;              // L
  two := '2';
  x := x.RoundToPrecision(dpcs);
  a := expa(x);
  b := expa(-x);
  c := a + b;
  c := c.RoundToPrecision(dpcs);
  result := c / two;
end;

// tanh(x) = (e^x - e^-x) / (e^x + e^-x)
function tanh_big(x : bigdecimal): bigdecimal;
var
  dpcs : integer;
  a, b, c, d : bigdecimal;
begin
  dpcs := BigDecimal.DefaultPrecision;              // L
  x := x.RoundToPrecision(dpcs);
  a := expa(x);
  b := expa(-x);
  c := a - b;
  c := c.RoundToPrecision(dpcs);
  d := a + b;
  d := d.RoundToPrecision(dpcs);
  result := c / d;
end;

// coth(x) = (e^x + e^-x) / (e^x - e^-x)
// x  0
function coth_big(x : bigdecimal): bigdecimal;
var
  dpcs : integer;
  a, b, c, d : bigdecimal;
begin
  dpcs := BigDecimal.DefaultPrecision;              // L
  x := x.RoundToPrecision(dpcs);
  a := expa(x);
  b := expa(-x);
  c := a + b;
  c := c.RoundToPrecision(dpcs);
  d := a - b;
  d := d.RoundToPrecision(dpcs);
  result := c / d;
end;

// sech(x) = 2 / (e^x + e^-x)
function sech_big(x : bigdecimal): bigdecimal;
var
  dpcs : integer;
  two, a, b, c : bigdecimal;
begin
  dpcs := BigDecimal.DefaultPrecision;              // L
  two := '2';
  x := x.RoundToPrecision(dpcs);
  a := expa(x);
  b := expa(-x);
  c := a + b;
  c := c.RoundToPrecision(dpcs);
  result := two / c;
end;

// csch(x) = 2 / (e^x  - e^-x)
// x  0
function csch_big(x : bigdecimal): bigdecimal;
var
  dpcs : integer;
  two, a, b, c : bigdecimal;
begin
  dpcs := BigDecimal.DefaultPrecision;                // L
  two := '2';
  x := x.RoundToPrecision(dpcs);
  a := expa(x);
  b := expa(-x);
  c := a - b;
  c := c.RoundToPrecision(dpcs);
  result := two / c;
end;

// x : @oȐ
// k :   oȐ
function hyperbolic(x: bigdecimal; k: integer): bigdecimal;
var
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
  zero: bigdecimal;
begin
  zero := '0';
  if k = 3 or 5 then begin
    if x = zero then begin
      application.MessageBox('csch(x)̈lx[łB','',0);
      result := '0';
      exit;
    end;
  end;
  pcsBack := BigDecimal.DefaultPrecision;             // LobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // ۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // wL + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  case k of
    0 : result := sinh_big(x);
    1 : result := cosh_big(x);
    2 : result := tanh_big(x);
    3 : result := coth_big(x);
    4 : result := sech_big(x);
    5 : result := csch_big(x);
    6 : result := exp_test(x);
  end;
  result := result.RoundToPrecision(pcsBack);         // wLɊۂ
  BigDecimal.DefaultPrecision := pcsBack;             // LA
  BigDecimal.DefaultRoundingMode := rmBack;           // ۂ߃[hA
end;

end.
